//+------------------------------------------------------------------+
//|                                                                  |
//|                      Copyright  2008, Trevor.                   |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern string EA_Settings = " --- EA Settings --- ";
extern int MagicNumber = 123;
extern int TP = 30;
extern double Lots = 0.1;
extern int Slippage = 3;
extern int Offset = 5;

extern string HoursSettings = "--- Hours Settings ---";
extern int StartHour = 0;
extern int StartMinute = 0;
extern int EndHour = 23;    
extern int EndMinute = 59;
extern bool EnableHours = false; 

extern string TrailingStop = "--- Trailing Stop Manager --- ";
extern int TS = 6;
extern int TrailStep = 6;
extern bool onlyTrailProfits = false;
extern bool enableTS = false;

bool okHighBreak,okLowBreak,okTrade;
int auxStep;
datetime barTime;

int init(){
   
   okHighBreak = false;
   okLowBreak = false;
   okTrade = true;
   auxStep = 0;   

   return(0);
}
int deinit(){

   

   return(0);
}



int EAOrders(){
   int count = 0;  
   
   for(int i =0;i<=OrdersTotal();i++){
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == true){
         if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber)){
            count=count+1;   
         }
      }
   }
   
   return(count);
}

/*********************************************** Closing Orders **********************************************************/


/*********************************************** Closing Orders **********************************************************/

/*********************************************** Ea Indicator Entry **********************************************************/


bool Entry(bool up_down, int shift) {

   
   
   if (up_down == true){
      
      if (MarketInfo(Symbol(),MODE_BID) > iHigh(Symbol(),Period(),1)+Offset*MarketInfo(Symbol(),MODE_POINT)){
         okHighBreak = true;
         okLowBreak = false;
         barTime = Time[0];
      }  

      if ((barTime == Time[0]) && (okHighBreak == true) && (MarketInfo(Symbol(),MODE_BID) < iClose(Symbol(),Period(),1))){
         okHighBreak = false;
         okLowBreak = false;
         return(true);
      }
   }
   else{
  
      if (MarketInfo(Symbol(),MODE_BID) < iLow(Symbol(),Period(),1)-Offset*MarketInfo(Symbol(),MODE_POINT)){ 
         okLowBreak = true;
         okHighBreak = false;
         barTime = Time[0];
      }

      if ((barTime == Time[0]) && (okLowBreak == true) && (MarketInfo(Symbol(),MODE_BID) > iClose(Symbol(),Period(),1))){
         okHighBreak = false;
         okLowBreak = false;
         return(true);
      } 
   }
   
   return(false);
}
/*********************************************** Ea Indicator Entry **********************************************************/

void trailingStopManager(int TS,int TrailStep, bool onlyTrailProfits,bool enableTS){
   
   double pointer, bidder, asker;
   
   if (enableTS == true){
   
      for(int cnt=0;cnt<OrdersTotal();cnt++){
   
         if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES) == true){
            if ((TS>0) && (Symbol() == OrderSymbol()) && (OrderMagicNumber() == MagicNumber)){
      
               bidder  = MarketInfo(OrderSymbol(),MODE_BID);
               asker   = MarketInfo(OrderSymbol(),MODE_ASK);
               pointer = MarketInfo(OrderSymbol(),MODE_POINT);
         
               if (OrderType()==OP_BUY){
                  if ((bidder-OrderOpenPrice()>TrailStep*pointer*TS) || onlyTrailProfits==false){
                     if (OrderStopLoss()<bidder-TrailStep*pointer*TS){
                        OrderModify(OrderTicket(),OrderOpenPrice(),bidder-TrailStep*pointer*TS,OrderTakeProfit(),0,Green); 
                     }
                  }
               }
               else if (OrderType()==OP_SELL){
                  if ((OrderOpenPrice()-asker>TrailStep*pointer*TS) || onlyTrailProfits==false){
                     if ((OrderStopLoss()>(asker+TrailStep*pointer*TS)) || (OrderStopLoss()==0)){
                        OrderModify(OrderTicket(),OrderOpenPrice(),asker+TrailStep*pointer*TS,OrderTakeProfit(),0,Red); 
                     }
                  }
               }
            }//tsV  
         }
      }//for   
   }  
}


bool TimeEntry(){

   if (EnableHours == true){

      if ((((TimeHour(TimeCurrent()) == StartHour) && (TimeMinute(TimeCurrent()) >= StartMinute)) || (TimeHour(TimeCurrent()) > StartHour)) && ((TimeHour(TimeCurrent()) < EndHour-1) || ((TimeHour(TimeCurrent()) == EndHour) && (TimeMinute(TimeCurrent()) <= EndMinute)))){
         return(true);
      }
   }
   else{
      return(true);
   }

   return(false); 
}

int start(){
   
   static datetime dtBarTime = 0;
   static int ticket;
   
   
   trailingStopManager(TS,TrailStep,onlyTrailProfits,enableTS);
   
   if (okTrade == true){
      if ((EAOrders() == 0) && (TimeEntry() == true)){
         if (Entry(true,1) == true){
            //Print("Sell");
            OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,Digits),Slippage,NormalizeDouble(iHigh(Symbol(),Period(),1),Digits),NormalizeDouble(Bid-TP*MarketInfo(Symbol(),MODE_POINT),Digits),"",MagicNumber,0,Red);   
            okTrade = false;
         }
         if (Entry(false,1) == true){ //close
            //Print("Buy");
            OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),Slippage,NormalizeDouble(iLow(Symbol(),Period(),1),Digits),NormalizeDouble(Ask+TP*MarketInfo(Symbol(),MODE_POINT),Digits),"",MagicNumber,0,Green);
            okTrade = false;
         }
      }
   }
   
   //Print(Time[0]);
   if (dtBarTime == Time[0]) return(0);  
   dtBarTime = Time[0];

   
   if (EAOrders() == 0){
      okHighBreak = false;
      okLowBreak = false;
      okTrade = true;
      //closeAllOrders();
   }
   return(0);
}